// s (because fancy prefix and easy to type) and f (because also fast to type, from "fancy")
// formats `body` as Departure Mono. for variable/highlighting purposes.
#let sf(body) = text(font: "Departure Mono", body);


#let generic(numbering: true, author: "Jade", date: datetime.today().display(), title: "Document", doc, subtitle: "", coverpage: false, coverpage_footer: "", outline: false) = {
  // Word abbreviations
  show "afg": "Aufgabe";
  show "def": "Definition";
  show "bsp": "Beispiel";
  show "zb": "zum Beispiel";
  show "wdh": "Wiederholung";

  // symbol shortcuts
  show "->": sym.arrow.r;
  show "<-": sym.arrow.l;

  show heading: it => {
    set text(font: "Departure Mono")
    underline(it)
  }
  set text(font: "B612");

  set page(
    header: sf([
      #author /> #title#h(1fr)#date
    ]),
    footer: align(center, context sf([\~ #here().page() \~]))
  )

  set document(
    title: title,
    author: (author),
  )

  [
    #if coverpage {
      page(
        footer: if coverpage_footer != "" { 
          align(
            center, 
            text(font: "B612", size: 8pt, coverpage_footer)
          )
        },
        grid(
          rows: 2, 
          columns: 1,
          align(center + horizon)[
            #set text(font: "Departure Mono");
            #text(size: 48pt, title);
            #v(0.33em);
            #text(size: 24pt, subtitle);
            #text(size: 18pt, fill: rgb("#666"), date)
          ], 
          []
        )
      )
    }
    #if outline [
      #outline(indent: 2em);
      #pagebreak();
    ]
    doc
  ]
}

